#!/bin/sh

# To extract a set of .ttf files from an Apple .dfont do
# fondu file.dfont
# http://fondu.sourceforge.net/
out=/dev/null
ttf=$1
if [ ! -f $ttf ] ; then
  echo "$0 filename.ttf"
  exit 1
fi
name=$(basename $ttf .ttf)
tfm=${name}.tfm

# ttf2tfm $ttf -p T1-WGL4.enc
ttf2tfm $ttf -P 1 -E 0 -p T1-WGL4.enc > $out 2>&1

tmp1=$(mktemp XXXXXX.pl)
tmp2=$(mktemp XXXXXX)
tftopl $tfm $tmp1
cat > $tmp2 << 'EoF'
(LIGTABLE
 (LABEL C f)
 (LIG C i D 28)
 (STOP)
 (LABEL C -)
 (LIG C - D 21)
 (STOP)
 (LABEL D 21)
 (LIG C - D 22)
 (STOP))
EoF

let insertLine=$(grep -n "CHARACTER" $tmp1 | head -n 1 | cut -d : -f 1)-1
sed "${insertLine}r $tmp2" < $tmp1 > $name.pl 
rm $tmp1 $tmp2

pltotf $name.pl $tfm > $out 2>&1

cat > t1$name.fd << EoF
\ProvidesFile{t1$name.fd}[$ttf font]

\DeclareFontFamily{T1}{$name}{}

\DeclareFontShape{T1}{$name}{m}{n}{
   <-> $name
}{}

\DeclareFontShape{T1}{$name}{bx}{n}{<->ssub * lhandw/m/n}{}

\DeclareFontShape{T1}{$name}{m}{it}{<->ssub * ptm/m/it}{}
\DeclareFontShape{T1}{$name}{m}{sl}{<->ssub * ptm/m/sl}{}
\DeclareFontShape{T1}{$name}{m}{sc}{<->ssub * ptm/m/sc}{}

\DeclareFontShape{T1}{$name}{bx}{it}{<->ssub * ptm/b/it}{}
\DeclareFontShape{T1}{$name}{bx}{sl}{<->ssub * ptm/b/sl}{}
\DeclareFontShape{T1}{$name}{bx}{sc}{<->ssub * ptm/b/sc}{}

\pdfmapline{+$name\space <$ttf\space <T1-WGL4.enc}
EoF
